//
// problema meow
// meow O(N * Q * word_len)
// meow Mem(N * word_len);
//
#include <algorithm>
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

const int kMaxN = 1e5+5, kMod = 1e9+7, kMaxWordLen = 63;

inline int& Mod(int& a) {
    if (a >= kMod) {
        return a -= kMod;
    } else if (a < 0) {
        return a += kMod;
    } else {
        return a;
    }
}

int word_len;

int n;
int father[kMaxN];
vector<int> children[kMaxN];
int label[kMaxN];

int answer = 0;

int up[kMaxN][kMaxWordLen], down[kMaxN][kMaxWordLen];

void UpdateAnswer() {
    answer = 0;
    for (int node = 0; node < n; node += 1) {
        // update up
        for (int i = 0; i < word_len; i += 1) {
            up[node][i] = up[father[node]][i];
        }

        if (label[node] == 0) {
            continue;
        }

        Mod(up[node][label[node]] += up[node][label[node] - 1]);
        if (label[node] == word_len) {
            Mod(answer += up[node][word_len - 1]);
        }
    }
}

int main() {
    ifstream cin("meow.in");
    ofstream cout("meow.out");

    int q = 0;
    cin >> n >> word_len >> q;
    father[0] = n;
    up[n][0] = 1;   

    for (int i = 1; i < n; i += 1) {
        int x; cin >> x;
        father[i] = x;
        children[x].push_back(i);
    }
    
    for (int i = 0; i < n; i += 1) {
        cin >> label[i];
    }

    int sum = 0;
    for (int i = 0, node = n; i < q; i += 1, node += 1) {
        if (node == n) {
            node = 0;
        }
    
        cin >> label[node];
        UpdateAnswer();

        Mod(sum += 1LL * (i + 1) * answer % kMod);
    }

    cout << sum << '\n';

    return 0;
}
