//
// Problema meow
// meow O(Q * Wordlen)
// meow Mem(N * WordLen)
//
#include <algorithm>
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

const int kMaxN = 7000, kMod = 1e9+7, kMaxWordLen = 1000;

inline int& Mod(int& a) {
    if (a >= kMod) {
        return a -= kMod;
    } else if (a < 0) {
        return a += kMod;
    } else {
        return a;
    }
}

int word_len;

int n;
int father[kMaxN];
vector<int> children[kMaxN];
int label[kMaxN];

int answer = 0;

int up[kMaxN][kMaxWordLen], down[kMaxN][kMaxWordLen];

void RenewDown() {
    for (int node = n - 1; node >= 0; node -= 1) {
        for (int i = 1; i <= word_len; i += 1) {
            down[node][i] = 0;
        }

        for (auto itr : children[node]) {
            for (int i = 1; i <= word_len; i += 1) {
                Mod(down[node][i] += down[itr][i]);
            }
        }

        if (label[node] == 0) {
            continue;
        }

        if (label[node] == word_len) {
            Mod(down[node][word_len] += 1);
        } else {
            Mod(down[node][label[node]] += down[node][label[node] + 1]);
        }
    }

    answer = down[0][1];
}

int SolutionsHere(int node) {
    if (label[node] == 0) {
        return 0;
    }

    int ups = up[father[node]][label[node] - 1];
    int downs;
    
    if (label[node] == word_len) {
        downs = 1;
    } else {
        downs = down[node][label[node] + 1];
    }
    
    return 1LL * ups * downs % kMod;
}

void EraseLabel(int node) {
    if (label[node] == 0) {
        return;
    }

    if (label[node] == word_len) {
        Mod(down[node][word_len] -= 1);
    } else {
        Mod(down[node][label[node]] -= down[node][label[node] + 1]);
    }
    
    Mod(answer -= SolutionsHere(node));
}

void UpdateLabel(int node) {
    for (int i = 0; i <= word_len; i += 1) {
        up[node][i] = up[father[node]][i];
    }

    if (label[node] == 0) {
        return;    
    }

    Mod(up[node][label[node]] += up[node][label[node] - 1]);
    Mod(answer += SolutionsHere(node));
}

int main() {
    ifstream cin("meow.in");
    ofstream cout("meow.out");

    int q;
    cin >> n >> word_len >> q;
    father[0] = n;
    up[n][0] = 1;

    for (int i = 1; i < n; i += 1) {
        int x; cin >> x;
        father[i] = x;
        children[x].push_back(i);
    }
    
    for (int i = 0; i < n; i += 1) {
        cin >> label[i];
    }

    int sum = 0;
    for (int i = 0, node = n; i < q; i += 1, node += 1) {
        if (node == n) {
            node = 0;
            RenewDown();
        }

        int new_label;
        cin >> new_label;

        EraseLabel(node);
        label[node] = new_label;
        UpdateLabel(node);
        
        Mod(sum += 1LL * (i + 1) * answer % kMod);
        cerr << answer << '\n';
    }
    cout << sum << '\n';

    return 0;
}
