/* O(N * log VALMAX * log*N) */
#include <bits/stdc++.h>

using namespace std;

struct Range {
    int l, r, w;
};

struct DSU {
    vector<int> Link;
    
    DSU(int n) : Link(n, -1) {}

    int Find(int x) {
        if (Link[x] == -1)
            return x;
        return Link[x] = Find(Link[x]);
    }

    int Union(int a, int b) {
        a = Find(a); b = Find(b);
        if (a > b) swap(a, b);
        Link[b] = a;

        return a;
    }
};

pair<double, int> Evaluate2(double m, vector<Range> &ranges) {
    int n = ranges.back().r + 1;
    DSU dsu(n + 1);
    vector<pair<double, int>> DP(n + 1);

    auto reduce = [&](int now) {
        while (now > 0 && DP[now].first >= 0) {
            int ant = dsu.Find(now - 1);
            assert(ant != now);
            // cerr << "Merging: " << ant << " " << now << endl;
            DP[ant].first += DP[now].first;
            DP[ant].second = DP[now].second;
            now = dsu.Union(now, ant);
            assert(now == ant);
        }
    };

    int cursor = 0;
    double wacc = 0, total = 0;
    for(int e = 0; e < n; ++e) {
        // cerr << endl;
        // cerr << "At: " << e << endl;

        auto p = DP[dsu.Find(0)];
        p.first -= total + m;
        p.second += 1;
        DP[e + 1] = p;
        wacc = 0;
        // cerr << "asdasd" << p.first << endl;
        total += p.first;
        
        reduce(e + 1);


        // cerr << "total: " << total << endl;
        auto pp = DP[dsu.Find(0)];
        // cerr << "Optimal: " << pp.first << " " << pp.second << endl;

        int at = e + 1;
        // cerr << endl;

        while(cursor < ranges.size()) {
            auto &range = ranges[cursor];
            if(range.r == e) {
                // cerr << "Adding: " << range.l << " " << range.r << "\n";
                int now = dsu.Find(range.l + 1);
                DP[now].first += range.w;
                wacc += range.w;
                total += range.w;

                reduce(now);

                ++cursor;
            } else break;
        }


    }

    return DP[dsu.Find(0)];
}

int main() {
    ifstream cin("popcorn.in");
    ofstream cout("popcorn.out");

    int n, k;
    cin >> n >> k;
    
    vector<Range> ranges(n);
    for (auto &range : ranges) {
        cin >> range.l >> range.r >> range.w;
        range.r -= 1;
    }
    
    sort(ranges.begin(), ranges.end(), [](Range a, Range b) {
        return a.r < b.r;
    });

    double b = 0, e = 1e9;
    for (int it = 0; it < 64; ++it) {
        double m = (b + e) / 2;
        auto p = Evaluate2(m, ranges);
        if (p.second == k) break;
        if (p.second < k) e = m;
        else b = m;
    }





    double m = (b + e) / 2;
    auto p = Evaluate2(m, ranges);
    cout << int(round(p.first + m * k)) << endl;

    return 0;
}
